
/*
# Copyright (c) 2003-2004 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation in source and binary forms for non-commercial purposes and
# without fee is hereby granted, provided that the above copyright notice
# appear in all copies and that both the copyright notice and this permission
# notice appear in supporting documentation, and that any documentation,
# advertising materials, and other materials related to such distribution and
# use acknowledge that the software was developed by the University of
# Southern California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived from this
# software without specific prior written permission.
#
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT THE
# SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS PROVIDED "AS
# IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
# LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so noted when
# applicable.
# ----------------------------------------------------------------------------
#
# Primary author: Purushotham Kamath
#                 Sept  2004
#This material is based upon work supported by the Defense Advanced Research 
#Projects Agency under contract no. N66001-02-1-8939 issued by the Space and 
#Naval Warfare Systems Center (SPAWAR).  Any opinions, findings, and conclusions 
#or recommendations expressed in this material are those of the author(s) and 
#do not necessarily reflect the views of the Defense Advanced Research Projects
#Agency, SPAWAR, or the U.S. Government.
*/



#ifndef TXSCHED_H
#define TXSCHED_H



class TxSched :public EventHandler
{
private:

public:
	
	TxSched();
	virtual ~TxSched();
	virtual void process(Packet *);		
	virtual void handleevent(Packet *);		
	void dumpstats();

};

enum {TXSCHED_ALOHA=0, TXSCHED_SELFISH, TXSCHED_THRESHOLD,TXSCHED_OVERLAPSECTION, TXSCHED_OVERLAPSIZE, TXSCHED_OPTIMALSTATE};

class TxSched_Aloha: public TxSched
{

public:
	TxSched_Aloha();
	virtual ~TxSched_Aloha();
	virtual void process(Packet *);		
	virtual void handleevent(Packet *);		
void dumpstats();

};

class TxSched_Selfish: public TxSched
{
	int N;
	int w;
	int K;
	int A;

public:
	TxSched_Selfish(int, int, int, int);
	virtual ~TxSched_Selfish();
	virtual void process(Packet *);		
	virtual void handleevent(Packet *);		
void dumpstats();
};

class TxSched_Threshold: public TxSched
{
	int N;
	int w;
	int K;
	int A;
	double th;

public:
	TxSched_Threshold(int, int, int, int, double);
	virtual ~TxSched_Threshold();
	virtual void process(Packet *);		
	virtual void handleevent(Packet *);		
void dumpstats();
};

class TxSched_OverlapSection: public TxSched
{
	int N;
	int w;
	int K;
	int A;
	double th;

public:
	TxSched_OverlapSection(int, int, int, int, double);
	virtual ~TxSched_OverlapSection();
	virtual void process(Packet *);		
	virtual void handleevent(Packet *);		
void dumpstats();
};

class TxSched_OverlapSize: public TxSched
{
	int N;
	int w;
	int K;
	int A;
	double th;

public:
	TxSched_OverlapSize(int, int, int, int, double);
	virtual ~TxSched_OverlapSize();
	virtual void process(Packet *);		
	virtual void handleevent(Packet *);		
void dumpstats();
};

class TxSched_OptimalState: public TxSched
{
	int N;
	int w;
	int K;
	int A;
	double th;

public:
	TxSched_OptimalState(int, int, int, int);
	virtual ~TxSched_OptimalState();
	virtual void process(Packet *);		
	virtual void handleevent(Packet *);		
void dumpstats();
};
#endif

